/* BARTsmart BART Widget - (C) 2005, WoodWare: http://www.craigtheguru.com/bartwidget.php */

function showMessage(message,append,section)
{
	var bartTextDiv;
	if (section)
		bartTextDiv = document.getElementById(section);	
	else
		bartTextDiv = document.getElementById("bartText");
	
	if (append)
		message = bartTextDiv.innerHTML + "<br>" + message;

	bartTextDiv.innerHTML = message;
	bartTextDiv.style.visibility = 'visible';
} 

var widgetVersion = "0.7.5 beta";
var widgetVersionURL = "0.7.5beta";
var wid = '';

var reqCount = 0;
var maxRequests = 5;
var req = false;
var refreshPending = false;

function loadSchedule()
{
	if (widget)
	{
		var station_form = document.station_form;
	
		// var url = "http://g5.local/bart/index.php";
		var url = "http://www.craigtheguru.com/bart.php";

		url = url + "?template=xml";
		url = url + "&start_station="+station_form.start_station.value;
		url = url + "&end_station="+station_form.end_station.value;
		url = url + "&show_details=true";
		url = url + "&v="+widgetVersionURL;
		url = url + "&req_count="+reqCount;
		url = url + "&wid="+wid;
			
		loadXMLDoc(url);
		return;
	}
}

function loadXMLDoc(url) 
{
	if (window.XMLHttpRequest) 
	{
		if (! req)
		{	
			req = true;
			
			document.getElementById("loading_indicator").style.visibility = 'visible';	
			document.getElementById("loading").style.visibility = 'visible';			

			req = new XMLHttpRequest();
			req.onreadystatechange = processReqChange;
			req.open("GET", url, true);

			// SEND HEADER TO INDICATE BARTWIDGET CLIENT
			req.send(null);

			reqCount ++;
			
			setTimeout("abortReq()",1000 + reqCount * 2500);
		}
	}
}

function abortReq()
{
	if (req)
	{
		req.abort();		
		req = false;

		if (reqCount <= maxRequests)
		{
			document.getElementById("loading_indicator").style.visibility = 'hidden';	
			setTimeout("loadSchedule()",reqCount * 250);
		}
		else
		{
		
			var msg = '<br><br>';
			msg += "<table width='100%' height='100%'>";
			msg += "<tr><td align='center' valign='middle' width='100%' height='100%' style='background:#222222;'>";
			
			msg += "&nbsp;<br><span class='updateAlertText'>Error loading BART schedule.</span><br><br>&nbsp;";

			msg += "</td></tr>";
			msg += "</table>";

			showMessage(msg);
			showMessage("<span onClick='loadSchedule();'>Retry</span>",false,'footer');

			document.getElementById("loading_indicator").style.visibility = 'hidden';	
			document.getElementById("loading").style.visibility = 'hidden';

			reqCount = 0;
		}
	}
}

function goWoodWare()
{
	widget.openURL("http://www.craigtheguru.com/");
}

function processReqChange()
{
	if (req && req.readyState == 4)
	{
		if (req.status == 200) 
		{
			// processing...
			var msg = '';
			var responseXML = req.responseXML;
			req = false;

			var result = responseXML.getElementsByTagName("result");
			var result_text = result[0].firstChild.nodeValue;
			
			if (result_text == 'ERROR' || result_text != responseXML.getElementsByTagName("message")[0].firstChild.nodeValue)
			{
				var feed_message = responseXML.getElementsByTagName("message")[0].firstChild.nodeValue;

				msg = "<table width='100%' height='100%'>";
				msg += "<tr><td align='center' valign='middle' width='100%' height='100%' style='background:#222222;'>";
				
				msg += "&nbsp;<br><br><span class='updateAlertText'>"+feed_message+"</span><br><br>&nbsp;";
	
				msg += "</td></tr>";
				msg += "</table>";
					
				showMessage("<span onClick='loadSchedule();'>Reload</span>",false,'footer');
					
			}
			else if (result_text == 'OK')
			{
				var nwid = responseXML.getElementsByTagName("wid")[0].firstChild.nodeValue;
				if (wid != nwid)
				{
					wid = nwid;
					setPref('wid',nwid);
				}

				var footer_message = '';
				var feed_version = responseXML.getElementsByTagName("version")[0].firstChild.nodeValue;
				if (feed_version != widgetVersion && feed_version != "0.5b" && feed_version != "0.6b" && feed_version != "0.7 beta" && feed_version != "0.7.1 beta" && feed_version != "0.7.2 beta")
				{
					// Check if this version is supported by the feed...					
					var client_supported = responseXML.getElementsByTagName("client_supported")[0].firstChild.nodeValue;
					if (client_supported != 'TRUE' && client_supported != widgetVersion && client_supported != widgetVersionURL)
					{
				
						msg += "<table width='100%' height='100%'>";
						msg += "<tr><td align='center' valign='middle' width='100%' height='100%' style='background:#222222;'>";
						
						msg += "&nbsp;<br><span onClick='widget.openURL(\"http://www.craigtheguru.com/bartsmart.php?v="+widgetVersionURL+"\")' class='updateAlertText'>New version available!<br>(v. "+feed_version+")<br><br>Click for details...</span><br><br>&nbsp;";
	
						msg += "</td></tr>";
						msg += "</table>";

						result_text = "UPGRADE";
						showMessage("BARTsmart",false,'header');
						showMessage("Current Version: "+widgetVersion,false,'footer');
					}
					else
					{
						// footer_message = '<span align="center" onClick="loadSchedule();">R</span> ';
						footer_message += "<span onClick='widget.openURL(\"http://www.craigtheguru.com/bartsmart.php?v="+widgetVersionURL+"\");' class='updateAlertText'>New version available! <img src='images/SnapBack.png' height='10'></span>";
					}
				}

				if (result_text == 'OK')
				{
					var trains = responseXML.getElementsByTagName("train");
					
					var span = 3;
					var show_details = (station_form.show_details.checked == true);
					if (show_details) span ++;

					var header_style = '';//' style="background:#222222;"';
					
					msg += "<table width='100%'>";
					msg += '<tr><th'+header_style+'>Departs</th><th'+header_style+'>Line</th><th'+header_style+'>Arrives</th>';
					if (show_details) 
						msg+= '<th'+header_style+'>Details</th>';
					msg += "</tr>";

					msg += '<tr><td style="background:#CCCCCC;" colspan="'+span+'"> <!-- DIV --> </td></tr>';

					var short_message = '';
					var ever_was_multi = false;
					var is_multi_transfer = false;					
					for (var i = 0; i < trains.length; i++) 
					{	
						if (ever_was_multi && i > 2)
							break;

						is_multi_transfer = getElementTextNS("", "details", trains[i], 0).match(',');
						if (is_multi_transfer)
							ever_was_multi = true;

						msg += '<tr><td style="background:#222222;">';
	
						msg += getElementTextNS("", "depart_time", trains[i], 0);
						msg += '</td><td style="background:#222222;">';
	
						if (is_multi_transfer && show_details || show_details && getElementTextNS("", "details", trains[i], 0).match('ransfer'))
						{
							if (getElementTextNS("", "depart_line", trains[i], 0).match('/'))
							{
								ever_was_multi = true;
							}
							
							msg += getElementTextNS("", "depart_line", trains[i], 0).replace('/','/<br>');
						}
						else
							msg += getElementTextNS("", "depart_line", trains[i], 0);

						if (! show_details && getElementTextNS("", "details", trains[i], 0).match('ransfer'))
						{
							if (is_multi_transfer)
							{
								msg += ' <span style="opacity:0.9;"><img src="images/transfer.png"></span>';
								msg += ' <span style="opacity:0.9;"><img src="images/transfer.png"></span>';
							}
							else
								msg += ' <span style="opacity:0.9;"><img src="images/transfer.png"></span>';
						}
						msg += '</td><td style="background:#222222;">';
	
						msg += getElementTextNS("", "arrive_time", trains[i], 0);					
						if (show_details)
						{
							msg += '</td><td style="background:#222222;font-size:smaller;">';

							// msg += getElementTextNS("", "details", trains[i], 0).replace('Timed ','');
							
							if (getElementTextNS("", "details", trains[i], 0).match('ransfer'))
							{
								msg += '<span style="opacity:0.9;"><img src="images/transfer.png"></span> ';	
							}
							
							if (is_multi_transfer)
							{
								short_message = getElementTextNS("", "details", trains[i], 0).replace('Timed ','').replace('Transfer @ ',' ').replace(',','<br><span style="opacity:0.9;"><img src="images/transfer.png"></span> ');
	
								// short_message = short_message.length + ':' + short_message;
								if (short_message.length > 100)
								{
									short_message = short_message.replace('Oakland','Oak.').replace('<br>',' ');
								}
	
								msg += short_message;
							
							}
							else
							{
								short_message = getElementTextNS("", "details", trains[i], 0).replace('Timed ','').replace('Transfer @ ',' ');						

								if (short_message.length > 20)
								{
									ever_was_multi = true;								
								}
								
								msg += short_message;
							}	
						}
	
						msg += '</td></tr>';
					}
					
					msg += '<tr><td style="background:#CCCCCC;" colspan="'+span+'"> <!-- DIV --> </td></tr>';
					// msg += '<tr><td colspan="'+span+'" align="center" onClick="loadSchedule();" style="font-weight: bold;">'+responseXML.getElementsByTagName("time")[0].firstChild.nodeValue+'</td></tr>';
			
					msg += "</table>";

					if (footer_message == '')
						footer_message = '<span align="center" onClick="loadSchedule();">'+responseXML.getElementsByTagName("time")[0].firstChild.nodeValue+'</span>';
					// footer_message = wid + ' ' + footer_message;

					showMessage(footer_message,false,"footer");
					
					var station_text = getSelectText(document.station_form.start_station) + ' ' + getSelectText(document.station_form.end_station);
					var arrow_image = '<img src="images/arrow.png">';
					var bart_text_span = '<span onClick="swapAndReload();">';
					var station_text_span = '<span>';
					var bart_label = '<b>BART:</b>';
					
					var base_length = 30;	// 30 as full "XXXX -> YYYY"

					if (station_text.length > base_length) // "Downtown Berkeley Embarcadero"
						station_text_span = '<span style="font-size:smaller;">';
					if (station_text.length > base_length + 8)
					{
						station_text_span = '<span style="font-size:xx-small;">';						
						bart_text_span = '<span style="font-size:smaller;">';											
					}
					if (station_text.length > base_length + 15)
					{
						bart_label = '';
						station_text_span = '<span style="font-size:7pt;">';

						if (station_text.length > base_length + 22)
							arrow_image = '-';
					}
					
					var full_footer_message = bart_text_span + bart_label + '</span>'+station_text_span+' '+getSelectText(document.station_form.start_station) + arrow_image + getSelectText(document.station_form.end_station)+'</span>';
					full_footer_message = '<span class="link" onClick="swapAndReload();">'+full_footer_message+'</span>';

					showMessage(full_footer_message,false,"header");

				}
				
			} 
			else 
			{
				if (reqCount <= maxRequests)
				{
					abortReq();
					return;
				}
			
				msg = '<br><br>';
				msg += "<table width='100%' height='100%'>";
				msg += "<tr><td align='center' valign='middle' width='100%' height='100%' style='background:#222222;'>";
				
				msg += "&nbsp;<br><span class='updateAlertText' onClick='loadSchedule();'>Error loading BART schedule.</span><br.<br>&nbsp;";
	
				msg += "</td></tr>";
				msg += "</table>";

				showMessage("<span onClick='loadSchedule();'>Retry</span>",false,'footer');
		
			}
			
			showMessage(msg);
	
			document.getElementById("loading_indicator").style.visibility = 'hidden';	
			document.getElementById("loading").style.visibility = 'hidden';
			req = false;
			reqCount = 0;

			if (result_text == 'OK' && ! refreshPending)
			{
				refreshPending = true;
				setTimeout("refreshSchedule()",60000);
			}
		}

	}		
}



// retrieve text of an XML document element, including
// elements using namespaces
function getElementTextNS(prefix, local, parentElem, index) {
	var result = "";
	if (prefix && isIE) {
		// IE/Windows way of handling namespaces
		result = parentElem.getElementsByTagName(prefix + ":" + local)[index];
	} else {
		// the namespace versions of this method 
		// (getElementsByTagNameNS()) operate
		// differently in Safari and Mozilla, but both
		// return value with just local name, provided 
		// there aren't conflicts with non-namespace element
		// names
		result = parentElem.getElementsByTagName(local)[index];
	}
	if (result) {
		// get text, accounting for possible
		// whitespace (carriage return) text nodes 
		if (result.childNodes.length > 1) {
			return result.childNodes[1].nodeValue;
		} else {
			return result.firstChild.nodeValue;    		
		}
	} else {
		return '&nbsp;';
		// return "n/a";
	}
}


function getPref(key)
{
	if(window.widget && key)
	{
		return widget.preferenceForKey(key);
	}
}

function setPref(key,preference)
{
	if(window.widget && key)
	{
		widget.setPreferenceForKey(preference,key);
	}
}

function toggleCheckbox(checkbox)
{
	if (checkbox.checked == true)
		checkbox.checked = false;
	else
		checkbox.checked = true;
}

function swapAndReload()
{
	swapStations();
	setTimeout("loadSchedule()",100);
}

function swapStations()
{
	var temp = document.station_form.start_station.value;
	setSelect(document.station_form.start_station,document.station_form.end_station.value);
	setSelect(document.station_form.end_station,temp);
	
	savePrefs();
}

function randomStations()
{	
	var opt1 = document.station_form.start_station.options[Math.round(Math.random() * document.station_form.start_station.options.length)].value;
	var opt2 = document.station_form.end_station.options[Math.round(Math.random() * document.station_form.end_station.options.length)].value;
	
	setSelect(document.station_form.start_station,opt1);
	setSelect(document.station_form.end_station,opt2);
	
	savePrefs();
	hideBack();
}

function setSelect(form_element,value)
{
	for(index = 0; index < form_element.length; index++)
		if(form_element[index].value == value)
		{
			form_element.selectedIndex = index;
			return;
		}
}

function getSelectText(form_element)
{
	for(index = 0; index < form_element.options.length; index++)
		if (form_element.options[index].value == form_element.value)
			return form_element.options[index].innerHTML;
	
	return false;
}

function savePrefs()
{
	setPref('start_station',document.station_form.start_station.value);
	setPref('end_station',document.station_form.end_station.value);
	setPref('show_details',document.station_form.show_details.checked);
}

function initWidget()
{
	if (window.widget) 
	{
		// configure the widget
		widget.onhide = onhide;
		widget.onshow = onshow;

		// Init backside interface elements
		var doneButton = document.getElementById('done');
		createGenericButton (doneButton, 'Done', hideBack);	

		// var swapButton = document.getElementById('swap_button2');
		// createGenericButton (swapButton, 'Swap', swapStations );	

		var start_pref = getPref('start_station');
		if (start_pref)
			setSelect(document.station_form.start_station, start_pref);

		var end_pref = getPref('end_station');
		if (end_pref)
			setSelect(document.station_form.end_station, end_pref);

		var details_pref = getPref('show_details');
		if (details_pref)
			document.station_form.show_details.checked = true;

		var wid_pref = getPref('wid');
		if (wid_pref)
			wid = wid_pref;

		// trigger show event
		setTimeout ('onshow()', 250);

	}
}

var onscreen = true;
function onshow() 
{
	onscreen = true;
	setTimeout("loadSchedule()",250);
}

function onhide() 
{
	onscreen = false;
}

function refreshSchedule()
{
	if (onscreen)
		loadSchedule();
	refreshPending = false;
}

function showBack()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

  	exitflip();
        
    if (window.widget)
        widget.prepareForTransition("ToBack");
                
    front.style.display="none";
    back.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hideBack()
{
	savePrefs();
	loadSchedule();

    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if (window.widget)
        widget.prepareForTransition("ToFront");
                
    back.style.display="none";
    front.style.display="block";
  
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event)
{
    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}
function mouseexit (event)
{
    if (flipShown)
    {
        // fade in the info button
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}
function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
                
        
    T = limit_3(time-animation.starttime, 0, animation.duration);
        
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
        
    animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

function enterflip(event)
{
    document.getElementById('fliprollie').style.display = 'block';
}
function exitflip(event)
{
    document.getElementById('fliprollie').style.display = 'none';
}
